int DIR1=23, PWM1=22, PWM2=21, DIR2=20, DC=192; //DC=75%

void setup() {
  Serial1.begin(115200);
  delay(100);
  pinMode(DIR1,OUTPUT);
  pinMode(DIR2,OUTPUT);
  analogWrite(PWM1,0);
  analogWrite(PWM2,0);
}

void loop() {
 unsigned char serialData[7];
 int i=0;
    while(Serial1.available())
    {
      serialData[i] = Serial1.read();
      delay(10);
      if ( (serialData[i]=='0') ) {
        digitalWrite(DIR1,HIGH);
        digitalWrite(DIR2,HIGH);
        analogWrite(PWM1,0);
        analogWrite(PWM2,0); //Serial.println("STOP");
      }
      if ( (serialData[i]=='1') && (serialData[i-1]=='5') ) {
        digitalWrite(DIR1,HIGH);
        digitalWrite(DIR2,HIGH);
        analogWrite(PWM1,DC);
        analogWrite(PWM2,DC); //Serial.println("Up");
      }
      if ( (serialData[i]=='1') && (serialData[i-1]=='6') ) {
        digitalWrite(DIR1,LOW);
        digitalWrite(DIR2,LOW);
        analogWrite(PWM1,DC);
        analogWrite(PWM2,DC); //Serial.println("Down");
      }
      if ( (serialData[i]=='1') && (serialData[i-1]=='7') ) {
        digitalWrite(DIR1,HIGH);
        digitalWrite(DIR2,LOW);
        analogWrite(PWM1,DC);
        analogWrite(PWM2,0);//Serial.println("Left");
      }
      if ( (serialData[i]=='1') && (serialData[i-1]=='8') ) {
        digitalWrite(DIR1,LOW);
        digitalWrite(DIR2,HIGH);
        analogWrite(PWM1,0);
        analogWrite(PWM2,DC);//Serial.println("Right");
      }
      if ( (serialData[i++]==0x0a) ) i=0;
    }
    delay(100);
}
