#include <Adafruit_NeoPixel.h>
const int ringLEDs = 24; // there are 24 addressable LEDs on Zip Halo
const int pinDriver = 0; // addressable LEDs are driven by pin P0
Adafruit_NeoPixel ring = Adafruit_NeoPixel(ringLEDs, pinDriver);
unsigned long red = ring.Color(255, 0, 0);
unsigned long green = ring.Color(0, 255, 0);
unsigned long blue = ring.Color(0, 0, 255);
unsigned long cyan = ring.Color(0, 255, 255);
unsigned long magenta = ring.Color(255, 0, 255);
unsigned long yellow = ring.Color(255, 255, 0);
unsigned long white = ring.Color(255, 255, 255);
unsigned long black = ring.Color(0, 0, 0); // turn LEDs OFF
unsigned char randomColor;


void setup()
{
  ring.begin();              // start the NeoPixel display
  ring.setBrightness(16);    // brightness range: 0-255
  randomSeed(analogRead(0)); // feed random number generator
}

void loop()
{

  while(1){
    
    randomColor = random(1,3); // generate random number between 1-3 (maximum 3 is exluded)

    for (int k = 0; k < ringLEDs; k++) {
      if (randomColor==1) ring.setPixelColor(k, green);
      else ring.setPixelColor(k, red);
      ring.show();  
    }
    
    delay(250);
  }   
}
